// MyFormView.cpp : implementation file
//

#include "stdafx.h"
#include "Switch.h"
#include "MainFrm.h"
#include "MyFormView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMyFormView

IMPLEMENT_DYNCREATE(CMyFormView, CFormView)

CMyFormView::CMyFormView()
	: CFormView(CMyFormView::IDD)
{
	//{{AFX_DATA_INIT(CMyFormView)
	m_curBottom = 0;
	m_curLeft = 0;
	m_curRight = 0;
	m_curTop = 0;
	//}}AFX_DATA_INIT
}

CMyFormView::~CMyFormView()
{
}

void CMyFormView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMyFormView)
	DDX_Control(pDX, IDC_CURRENTRECT, m_SelectedRect);
	DDX_Text(pDX, IDC_EDITBOTTOM, m_curBottom);
	DDX_Text(pDX, IDC_EDITLEFT, m_curLeft);
	DDX_Text(pDX, IDC_EDITRIGHT, m_curRight);
	DDX_Text(pDX, IDC_EDITTOP, m_curTop);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMyFormView, CFormView)
	//{{AFX_MSG_MAP(CMyFormView)
	ON_CBN_SELENDOK(IDC_CURRENTRECT, OnRectSelection)
	ON_BN_CLICKED(IDC_UPDATERECT, OnUpdateRect)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMyFormView diagnostics

#ifdef _DEBUG
void CMyFormView::AssertValid() const
{
	CFormView::AssertValid();
}

void CMyFormView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CSwitchDoc* CMyFormView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CSwitchDoc)));
	return (CSwitchDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMyFormView message handlers

void CMyFormView::OnInitialUpdate() 
{
	CSwitchDoc* pDoc = (CSwitchDoc*)GetDocument();
	ASSERT_VALID(pDoc);

	CFormView::OnInitialUpdate();
	
	m_SelectedRect.SetCurSel(0);

    OnUpdate(this, 0, NULL);
}

void CMyFormView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	CSwitchDoc* pDoc = (CSwitchDoc*)GetDocument();
	ASSERT_VALID(pDoc);
	
	CString rectSel, rectNum;
	int rectIndex;

	m_SelectedRect.GetWindowText(rectSel);
	rectNum= rectSel.Right(1);
	rectIndex= atoi(rectNum)-1;
	if(rectIndex != -1)
	{
	 //fill in edit boxes
	 CMyRect selRect= pDoc->m_RectArray[rectIndex];

	 CPoint tmp;
	 tmp= selRect.TopLeft();
	 m_curLeft= tmp.x;
	 m_curTop= tmp.y;
 
	 tmp= selRect.BottomRight();
	 m_curRight= tmp.x;
	 m_curBottom= tmp.y;
	 UpdateData(FALSE);
	}
}

void CMyFormView::OnRectSelection() 
{
  OnUpdate(this, 0, NULL);
}

void CMyFormView::OnUpdateRect() 
{
	CSwitchDoc* pDoc = (CSwitchDoc*)GetDocument();
	ASSERT_VALID(pDoc);
	
	CString rectSel, rectNum;
	int rectIndex;

	UpdateData(TRUE);

	m_SelectedRect.GetWindowText(rectSel);
	rectNum= rectSel.Right(1);
	rectIndex= atoi(rectNum)-1;
	if(rectIndex != -1)
	{
	 //update rect with new values
	 CMyRect* selRect= &(pDoc->m_RectArray[rectIndex]);

	 selRect->SetRect(m_curLeft, m_curTop,
		 m_curRight, m_curBottom);
	}
	AfxGetMainWnd()->PostMessage(WM_COMMAND, ID_VIEW_VIEW1, 0);
}
